

;
;
;
; Set 50 screen lines
;

; Segment type: Pure code
seg000 segment byte public 'CODE'
assume cs:seg000, es:seg000,  ss:seg000,  ds:seg000 
org 100h




public start
start:
mov     ax, 500h
int     10h             ; SELECT DISPLAY PAGE
                        ; AL = display page, 0-7  for modes 0 & 1, 0-3  for modes 2 & 3
mov     ax, 1200h
mov     bl, 10h
xor     cx, cx
int     10h             ; GET EGA INFO
                        ; Return: BH = 00h color mode in effect CH = feature bits, CL = switch settings
or      cx, cx
jz      short beende
mov     bl, 30h
mov     ax, 1202h
int     10h             ; SELECT VERTICAL RESOLUTION
                        ; AL = vertical resolution: 400 scan lines
mov     ax, 7
or      bh, bh
jnz     short set_mode
mov     al, 3

set_mode:               ; SET VIDEO MODE
int     10h             ; AL = mode
mov     ax, 1112h
mov     bl, 0
int     10h             ;
                        ; AL = 00h, 10h: load user-specified patterns
                        ; AL = 01h, 11h: load ROM monochrome patterns (8 by 14)
                        ; AL = 02h, 12h: load ROM 8 by 8 double-dot patterns
                        ; AL = 03h: set block specifier
mov     dl, 20h
mov     ah, 2
int     21h             ; 
                        ; DL = character to send to standard output
mov     al, 8
mov     ah, 0Eh
xor     bh, bh
int     10h             ; WRITE CHARACTER AND ADVANCE CURSOR (TTY WRITE)
                        ; AL = character, BH = display page (alpha modes)
                        ; BL = foreground color (graphics modes)
mov     ah, 8
int     10h             ; READ ATTRIBUTES/CHARACTER AT CURSOR POSITION
                        ; BH = display page
                        ; Return: AL = character
                        ; AH = attribute of character (alpha modes)
mov     bh, ah
xor     cx, cx
mov     ax, 600h
mov     dx, 314Fh
int     10h             ; SCROLL PAGE UP
                        ; AL = number of lines to scroll window (0 = blank whole window)
                        ; BH = attributes to be used on blanked lines
                        ; CH,CL = row,column of upper left corner of window to scroll
                        ; DH,DL = row,column of lower right corner of window

beende:
mov     ax, 4C00h
int     21h             ; QUIT WITH EXIT CODE (EXIT)
                        ; AL = exit code

seg000 ends


end start
